function [ depth_resolution_fill ] = fillhole( depth_resolution )
    resolution=size(depth_resolution);
    holenum=sum(sum(depth_resolution<=0));
    X=zeros(resolution(1)*resolution(2)-holenum,2);
    V=zeros(resolution(1)*resolution(2)-holenum,1);
    Xq=zeros(holenum,2);
    counthole=0;
    countnonhole=0;
    for i=1:1:resolution(1)
        for j=1:1:resolution(2)
            if depth_resolution(i,j)>0
                countnonhole=countnonhole+1;
                X(countnonhole,1)=i;
                X(countnonhole,2)=j;
                V(countnonhole)=depth_resolution(i,j);
            else
                counthole=counthole+1;
                Xq(counthole,1)=i;
                Xq(counthole,2)=j;
            end
        end
    end
    interp=TriScatteredInterp(X,V,'nearest');
    Vq=interp(Xq);
    depth_resolution_fill=depth_resolution;
    counthole=0;
    for i=1:1:resolution(1)
        for j=1:1:resolution(2)
            if depth_resolution(i,j)<=0
                counthole=counthole+1;
                depth_resolution_fill(i,j)=Vq(counthole);
            end
        end
    end
end

