function [ smooth_map ] = segDenoise( depth,radius,denoiseparam )

depth_raw=depth;
[row,col]=size(depth);
percent = denoiseparam(1);
smooth_filter = zeros(radius*2+1,radius*2+1);
for i=1:1:radius*2+1
    for j=1:1:radius*2+1
        smooth_filter(i,j) = 1.0 / ((radius*2+1)*(radius*2+1));
    end
end
[x_index,y_index]=find(depth>0);
depthvalue=zeros(numel(x_index),1);
for iter=1:1:numel(x_index)
    depthvalue(iter,1)=depth(x_index(iter),y_index(iter));
end
[~,sortindex]=sort(depthvalue);
mediandepthvalue=median(depthvalue);
pernum=min(percent*numel(sortindex),denoiseparam(2));
x_index=[x_index(sortindex(1:ceil(pernum)));x_index(sortindex(max(numel(sortindex)-ceil(pernum),1):numel(sortindex)))];
y_index=[y_index(sortindex(1:ceil(pernum)));y_index(sortindex(max(numel(sortindex)-ceil(pernum),1):numel(sortindex)))];
for iter=1:1:numel(x_index)
    depth(x_index(iter),y_index(iter))=0;
end
smooth_map = depth;
for iter=1:1:numel(x_index)
    i=x_index(iter);
    j=y_index(iter);
    sumfilter=zeros((radius*2+1)*(radius*2+1),1);
    sumvalue=zeros((radius*2+1)*(radius*2+1),1);
    depthpatch=zeros(radius*2+1,radius*2+1);
    depthpatch(max(radius-i+1,1):max(radius-i+1,1)+min(i+radius,row)-max(i-radius,1),max(radius-j+1,1):max(radius-j+1,1)+min(j+radius,col)-max(j-radius,1))=depth(max(i-radius,1):min(i+radius,row),max(j-radius,1):min(j+radius,col));
    index=0;
    for ii=1:1:size(depthpatch,1)
        for jj=1:1:size(depthpatch,2)
            if depthpatch(ii,jj)>0
                index=index+1;
                sumvalue(index,1)=depthpatch(ii,jj);
                sumfilter(index,1)=smooth_filter(ii,jj);
            end
        end
    end
    sumfilter=sumfilter(1:index,1);
    sumvalue=sumvalue(1:index,1);
    [~,rankindex]=sort(sumvalue);
    chosenrankindex=rankindex;
    if numel(chosenrankindex)==0
        smooth_map(i,j)=0.5*mediandepthvalue+0.5*depth_raw(i,j);
    else
        smooth_map(i,j)=sum(sumfilter(chosenrankindex).*sumvalue(chosenrankindex))/sum(sumfilter(chosenrankindex));
    end
end

