function [seg_tree]=segTree(image,param)

addpath(genpath('./Segmentation/edison_matlab_interface'));
MinimumRegionArea=param.MinimumRegionArea;
[h,w,~]=size(image);
seg_tree = zeros(h,w,numel(MinimumRegionArea));
fprintf('seg number: ');
for i=1:1:numel(MinimumRegionArea)
    [fimage] = edison_wrapper(image, @RGB2Luv,'SpatialBandWidth',7,'RangeBandWidth',6.5,'MinimumRegionArea',MinimumRegionArea(i));
    rimage{i}=Luv2RGB(fimage);
    imwrite(rimage{i},['fimage_',num2str(i),'.png']);
    im_seg_image=rimage{i};
    im_seg_image=im2double(im_seg_image);
    if numel(size(im_seg_image))==3
        im_seg_image=rgb2gray(im_seg_image);
    end
    seg_image=classcategory(im_seg_image);
    seg_tree(:,:,i)=seg_image;
    seg_index=unique(seg_image);
    fprintf('%d ', numel(seg_index));
end
fprintf('\n');

badsegcount=0;
for i=numel(MinimumRegionArea):-1:2
    curimage=seg_tree(:,:,i);
    previmage=seg_tree(:,:,i-1);
    for j = 1:1:numel(unique(curimage))
        prevnode = zeros(size(previmage));
        prevnode(curimage==j)=previmage(curimage==j);
        prevnode_index=unique(prevnode);
        if numel(prevnode_index)>2
            badsegcount=badsegcount+1;
            areasize(1)=0;
            for k=2:1:numel(prevnode_index)
                [xindex,~]=find(prevnode==prevnode_index(k));
                areasize(k)=numel(xindex);
            end
            [~,aindex]=max(areasize);
            previmage(curimage==j)=prevnode_index(aindex(1));
            clear areasize;
        end
    end
    seg_tree(:,:,i-1)=previmage;
end
fprintf('Bad Segmentation Num: %f \n', badsegcount);

end
