function [ result_depth ] = smoothSimple( depth, calib, upscalefactor,param )

if param.isfillhole
    relativezero=0;
else
    relativezero=1e-3;
end

result_depth=depth;
[row,col]=size(depth);
row_scale=upscalefactor;
col_scale=upscalefactor;
grid_scale=[2*min(row_scale,col_scale),2*min(row_scale,col_scale)];
[x_index,y_index]=find(calib>relativezero);
matrixIndex=zeros(size(calib));
matrixY=zeros(numel(x_index),1);
matrixC=zeros(numel(x_index),1);
for i=1:1:numel(x_index)
    matrixIndex(x_index(i),y_index(i))=i;
    matrixY(i,1)=calib(x_index(i),y_index(i));
    matrixC(i,1)=depth(x_index(i),y_index(i));
end

matrixA=zeros(numel(x_index),numel(x_index));
for i=1:1:numel(x_index)
    indexpatch=matrixIndex(max(x_index(i)-grid_scale(1),1):min(x_index(i)+grid_scale(1),row),max(y_index(i)-grid_scale(2),1):min(y_index(i)+grid_scale(2),col));
    indexpatchcenter=[x_index(i)+1-max(x_index(i)-grid_scale(1),1),y_index(i)+1-max(y_index(i)-grid_scale(2),1)];
    [i_index,j_index]=find(indexpatch>0);
    weight=(1-sqrt((i_index-indexpatchcenter(1)).^2+(j_index-indexpatchcenter(2)).^2)/sqrt(grid_scale(1)^2+grid_scale(2)^2)).^2;
    for j=1:1:numel(i_index)
        matrixA(i,indexpatch(i_index(j),j_index(j)))=weight(j,1);
    end
end
matrixAnorm=sum(matrixA,2);
matrixAnorm=max(matrixAnorm,1e-10);

for i=1:1:size(matrixA,2)
    matrixA(:,i)=matrixA(:,i)./matrixAnorm;
end
matrixX=matrixA\(matrixY-matrixC);
[x_index_all,y_index_all]=find(depth>0);
matrixIndex_all=zeros(size(depth));
for i=1:1:numel(x_index_all)
    matrixIndex_all(x_index_all(i),y_index_all(i))=i;
end
matrixC_all=zeros(numel(x_index_all),1);
for i=1:1:numel(x_index_all)
    matrixC_all(i,1)=depth(x_index_all(i),y_index_all(i));
end

matrixA_all=spalloc(numel(x_index_all),numel(x_index),numel(x_index_all)*100);
for i=1:1:numel(x_index)
    depthpatch=depth(max(x_index(i)-grid_scale(1),1):min(x_index(i)+grid_scale(1),row),max(y_index(i)-grid_scale(2),1):min(y_index(i)+grid_scale(2),col));
    indexpatch=matrixIndex_all(max(x_index(i)-grid_scale(1),1):min(x_index(i)+grid_scale(1),row),max(y_index(i)-grid_scale(2),1):min(y_index(i)+grid_scale(2),col));
    indexpatchcenter=[x_index(i)+1-max(x_index(i)-grid_scale(1),1),y_index(i)+1-max(y_index(i)-grid_scale(2),1)];
    [i_index,j_index]=find(depthpatch>0);
    weight=(1-sqrt((i_index-indexpatchcenter(1)).^2+(j_index-indexpatchcenter(2)).^2)/sqrt(grid_scale(1)^2+grid_scale(2)^2)).^2;
    for j=1:1:numel(i_index)
        matrixA_all(indexpatch(i_index(j),j_index(j)),i)=weight(j,1);
    end
end

if param.isexpanddetail
    grid_scale=[5*min(row_scale,col_scale),5*min(row_scale,col_scale)];
    matrixAnorm=sum(matrixA_all,2);
    for i=1:1:numel(x_index)
        depthpatch=depth(max(x_index(i)-grid_scale(1),1):min(x_index(i)+grid_scale(1),row),max(y_index(i)-grid_scale(2),1):min(y_index(i)+grid_scale(2),col));
        indexpatch=matrixIndex_all(max(x_index(i)-grid_scale(1),1):min(x_index(i)+grid_scale(1),row),max(y_index(i)-grid_scale(2),1):min(y_index(i)+grid_scale(2),col));
        indexpatchcenter=[x_index(i)+1-max(x_index(i)-grid_scale(1),1),y_index(i)+1-max(y_index(i)-grid_scale(2),1)];
        [i_index,j_index]=find(depthpatch>0);
        weight=(1-sqrt((i_index-indexpatchcenter(1)).^2+(j_index-indexpatchcenter(2)).^2)/sqrt(grid_scale(1)^2+grid_scale(2)^2)).^2;
        for j=1:1:numel(i_index)
            if matrixAnorm(indexpatch(i_index(j),j_index(j)))==0
                matrixA_all(indexpatch(i_index(j),j_index(j)),i)=weight(j,1);
            end
        end
    end
end

matrixAnorm=sum(matrixA_all,2);
matrixAnorm=max(matrixAnorm,1e-10);
for i=1:1:size(matrixA_all,2)
    matrixA_all(:,i)=matrixA_all(:,i)./matrixAnorm;
end
matrixY_all=matrixA_all*matrixX+matrixC_all;
result_depth(depth>0)=matrixY_all;
if abs(sum(sum(result_depth(calib>relativezero)-calib(calib>relativezero))))>1e-5 || sum(sum(isnan(result_depth)))>0
    disp('Error!!!');
end

end

